#!/usr/bin/env ruby

$KCODE="e"

$rqr="RQR 0.1.8"

$strPath=File.split(`#{"which rqr.rb"}`.chomp)[0]+"/"
$strBinQr=$strPath+"rqr/qr"
$strZDBAT=`#{"which zdbat"}`.chomp
$strOrigAdr="/home/zaurus/Applications/dtm/SLADRS.IDX"
$astrQr=nil
$iVer=nil

require 'jcode'
require 'csv'
require 'qte'
require 'qpe'

include Qte
include Qpe

$strDocomo="DoCoMo"
$strAu="AU"
$strVodafone="Vodafone"

$codec = QTextCodec.codecForName("Shift-JIS")
$ecodec = QTextCodec.codecForName("EUC-JP")

$strZen="ĥƥȥʥ˥̥ͥΥϥҥեإޥߥ󥡥礢ĤƤȤʤˤ̤ͤΤϤҤդؤۤޤߤ浪󤡤£ãģţƣǣȣɣʣˣ̣ͣΣϣУѣңӣԣգ֣ףأ٣ڣɡǡʡˡܡΡϡ֡סСѡ"

$strHan='ÎĎŎƎǎȎɎʎˎ͎̎ΎώЎюҎӎԎՎ֎׎؎َڎێ܎ݎ֎ÎĎŎƎǎȎɎʎˎ͎̎ΎώЎюҎӎԎՎ֎׎؎َڎێ܎ݎabcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789!\"#$%&\'()~^=+[]{};:*\\|'

$strZenDaku=["","","","","","","","","","","","","","","","","","","","","","","","","",
             "","","","","","","","","","","","","","","","","","","","","","","","",""]

$strHanDaku=["","","","","","","","","","","","","","Î","Ď","ʎ","ˎ","̎","͎","Ύ","ʎ","ˎ","̎","͎","Ύ",
             "","","","","","","","","","","","","","Î","Ď","ʎ","ˎ","̎","͎","Ύ","ʎ","ˎ","̎","͎","Ύ"]

$chrZero = "0"[0]

class String
  def replaceString
    gsub(/\\/,"\\\\").gsub(/:/,"\\:").gsub(/;/,"\\;").gsub(/,/,"\\,")
  end
  def zen2han
    $strZenDaku.each_with_index do |strOne,i|
       gsub!(strOne,$strHanDaku[i])
    end
    tr($strZen,$strHan)
  end
end

class RqrEnv
  def initialize
  end
  def deviceName
    strDevice = ""
    fp = File.new("/proc/deviceinfo/product","r")
    fp.each do |line|
      strDevice = line
    end
    return strDevice
  end
  def getDesktopWidth
    QApplication.desktop.width
  end
  def getDesktopHeight
    QApplication.desktop.height
  end
  def vgaScreen?
    if getDesktopWidth == 640 or getDesktopHeight== 640 then
      true
    else
      false
    end
  end
  def largeScreen?
    vgaScreen?
  end
  def defaultDialogSize
    if largeScreen? then
      370
    else
      200
    end
  end
end

class RqrConf
  def initialize(strFile = "/home/zaurus/Settings/rqr.conf")
    @strConfFile = strFile
    @hDefaultConf = {
      "sizeFont" => "6",
      "sizeMailFont" => "6",
      "sizeAdrsFont" => "3",
      "sizeAdrsBanchiFont" => "3",
      "sizeQr" => "0",
      "bMargin" => "TRUE",
      "pathCurPix" => "/home/zaurus/Documents/rqr.jpeg",
      "pathQrTmp" => "/tmp/qrinput.txt",
      "pathAdrTmp" => "/tmp/qradrinput.txt",
      "pathMailOutbox" => "/home/zaurus/Documents/application/rqr/outbox",
      "lastScreen" => "0",
      "strLastAdrs" => "",
#      "bHan" => "TRUE",
      "bSavePix" => "FALSE",
      "strKeitai" => $strDocomo
    }
    if $env.getDesktopWidth != 640 and $env.getDesktopHeight != 640 then 
      @hDefaultConf["sizeFont"] = "2"
      @hDefaultConf["sizeMailFont"] = "2"
      @hDefaultConf["sizeAdrsFont"] = "2"
      @hDefaultConf["sizeAdrsBanchiFont"] = "2"
    end
    if FileTest.directory?("/home/zaurus/")==false then
      @hDefaultConf["pathCurPix"] ="/home/root/Documents/rqr.jpeg"
      @hDefaultConf["pathMailOutbox"] ="/home/root/Documents/application/rqr/outbox"
    end
    @hConf=@hDefaultConf
    load
  end
  def load
    if FileTest.file?(@strConfFile)==false then
      save
      return @hConf
    end
    fp = File.new(@strConfFile,"r")
    fp.each do |line|
      line = line.chomp
      unless line =~ /^$/
        a = line.split("=",2)
        @hConf[a[0]]=a[1]
      end
    end
    fp.close
    @hDefaultConf.each do |k, v|
      unless @hConf.has_key?(k)
        @hConf[k]=v
      end
    end
    save
    return @hConf
  end
  def getConf
    @hConf
  end
  def setConf(h)
    @hConf=h
    save
  end
  def save
    fp = File.new(@strConfFile,"w")
    @hConf.each do |k, v|
      fp.print(k + "=" + v + "\n")
    end
    fp.close
  end
end

class RqrSetPixSizeDialog < QDialog
  def initialize
    super(nil, "RqrSetPixSizeDialog", true) # Modal Dialog
    setCaption(tr(""))
    vb=QVBox.new(self)
    if $env.largeScreen? then
      vb.setFixedSize(200,120)
    else
      vb.setFixedSize(100,100)
    end
      @ckAuto=QCheckBox.new(tr("ưĴ"),vb)
      QLabel.new(tr("åʤ硢\nꤷޤ"),vb)
      hb=QHBox.new(vb)
        @sbSize=QSpinBox.new(hb)
        QLabel.new(tr("ԥ"),hb)
        @sbSize.setMinValue(0)
        @sbSize.setMaxValue($env.defaultDialogSize)
      @ckMargin=QCheckBox.new(tr("ޡ"),vb)
      connect(@ckAuto,QSIGNAL("stateChanged(int)"),self,"tglCheck(i)")
  end
  def exec
    h=$conf.getConf
    if h["sizeQr"]=="0" then
      @ckAuto.setChecked(true)
      @sbSize.setValue(100)
      @sbSize.setEnabled(false)
    else
      @ckAuto.setChecked(false)
      @sbSize.setValue(h["sizeQr"].to_i)
      @sbSize.setEnabled(true)
    end
    if h["bMargin"]=="TRUE" then
      @ckMargin.setChecked(true)
    else
      @ckMargin.setChecked(false)
    end
    super
  end
  def getConf
    h=$conf.getConf
    if @ckAuto.isChecked then
      h["sizeQr"]="0"
    else
      h["sizeQr"]=@sbSize.value.to_s
    end
    if @ckMargin.isChecked then
      h["bMargin"]="TRUE"
    else
      h["bMargin"]="FALSE"
    end
    h
  end
  def tglCheck(i)
    case i
    when 0
      @sbSize.setEnabled(true)
    when 2
      @sbSize.setEnabled(false)
    end
  end
end

class RqrDialog < QDialog
  def initialize
    super(nil, "RqrDialog", true) # Modal Dialog
    setCaption(tr($rqr))
    s=$env.defaultDialogSize
    @iBun=0
    @iCur=0
    @astrQr=nil
    vb=QVBox.new(self)
      @qrCanvas=RqrCanvas.new(vb)
      @qrCanvas.setFixedSize(s,s)
      h = QHBox.new(vb)
        @btnPrev=QPushButton.new(tr("<<"),h)
        @btnPrev.setFixedHeight(30)
        @leNo=QLabel.new("/",h)
        @leNo.setFixedHeight(30)
        @leNo.setAlignment(AlignCenter)
        @leLv=QLabel.new("Level:",h)
        @leLv.setFixedHeight(30)
        @leLv.setAlignment(AlignCenter)
        @btnNext=QPushButton.new(tr(">>"),h)
        @btnNext.setFixedHeight(30)
        @btnNext.setFocus
      vb.setFixedSize(s,s+@btnPrev.size.height)
      connect(@btnPrev,QSIGNAL("clicked()"),self,"prevQr")
      connect(@btnNext,QSIGNAL("clicked()"),self,"nextQr")
  end
  def getCanvas
    @qrCanvas
  end
  def prevQr
    if @iCur == 0 then 
      return
    end
    @iCur=@iCur-1
    drawQrMain
  end
  def nextQr
    if (@iCur+1) == @iBun then 
      return
    end
    @iCur=@iCur+1
    drawQrMain
  end

  def drawQr
    @iBun=$astrQr.size
    @iCur=0
    drawQrMain
  end
  def drawQrMain
    @leNo.setText((@iCur+1).to_s + " / " + @iBun.to_s)
    @leLv.setText("Level:" + $iVer.to_s)
    @qrCanvas.drawQr($astrQr[@iCur])
    @qrCanvas.paintEvent(nil)
  end
end

class RqrCanvas < QWidget
  def initialize(parent)
    super(parent)
    setPalette(QPalette.new(QColor.new(255,255,255)))
    @strQr=""
    @qpBuf=QPixmap.new($env.defaultDialogSize,$env.defaultDialogSize)
    @qpBuf.fill(QColor.new(255,255,255))
    @p=QPainter.new
    catchEvent
  end
  def drawQr(strQr)
    @strQr=strQr
    if @strQr!="" then
      astrQr = @strQr.split(/\n/)
      h=$conf.getConf

      if h["bMargin"]=="TRUE" then
        strVMargin = "0" * (astrQr.length + 12)
        astrQr.collect! {|strOne|
          "000000" + strOne + "000000"
        }
        astrQr.unshift(strVMargin)
        astrQr.unshift(strVMargin)
        astrQr.unshift(strVMargin)
        astrQr.unshift(strVMargin)
        astrQr.unshift(strVMargin)
        astrQr.unshift(strVMargin)
        astrQr.push(strVMargin)
        astrQr.push(strVMargin)
        astrQr.push(strVMargin)
        astrQr.push(strVMargin)
        astrQr.push(strVMargin)
        astrQr.push(strVMargin)
      end

      widthQr = astrQr[0].length

      h=$conf.getConf

      if h["sizeQr"]=="0" then

        s=widthQr*$iBlock
        i=$iBlock
        j=$iBlock
        if s>height then
          i=height.to_f/widthQr.to_f
          j=i.ceil
          s=widthQr*i
        end
        if s>width then
          i=width.to_f/widthQr.to_f
          j=i.ceil
          s=widthQr*i
        end

      else

        s=h["sizeQr"].to_i
        i=s.to_f/widthQr.to_f
        j=i.ceil

      end

      @qpBuf.resize(s,s)

      @qpBuf.fill(QColor.new(255,255,255))
      @p.begin(@qpBuf)
      @p.setBrush(QColor.new(0,0,0))
      @p.setPen(SolidLine)

      y = 0
      while y < widthQr
        strOne = astrQr[y]
        x = 0
        while x < widthQr
          if strOne[x]!=$chrZero then
            @p.drawRect(x*i, y*i, j, j)
          end
          x += 1
        end
        y += 1
      end
      @p.end
      if h["bSavePix"]=="TRUE" then
        if h["pathCurPix"][-1,1]=="/" then
          strDir = h["pathCurPix"]
          strFile = ""
        else
          astrFile = File.split(h["pathCurPix"])
          strDir=astrFile[0]
          strFile=astrFile[1]
        end
        while FileTest.directory?(strDir)==false or strFile=="" do
          $frmMain.selectFileName
          h = $conf.getConf
          if h["pathCurPix"][-1,1]=="/" then
            strDir = h["pathCurPix"]
            strFile = ""
          else
            astrFile = File.split(h["pathCurPix"])
            strDir=astrFile[0]
            strFile=astrFile[1]
          end
        end
        @qpBuf.save(h["pathCurPix"],"JPEG")
      end
    end
  end
  def paintEvent(e)
    bitBlt(self,width/2 - @qpBuf.width/2, height/2 - @qpBuf.height/2 ,@qpBuf)
  end
end

class RqrEdit < QMultiLineEdit
  def initialize(p, confKey="sizeFont")
    super(p)
    setWordWrap(WidgetWidth)
    setWrapPolicy(Anywhere)

    if FileTest.directory?("/home/zaurus/") then
      @aFontSize=[10,12,16,18,20,24,36,48,72]
    else
      @aFontSize=[10,12,16,18,20,24]
    end
    @confKey=confKey
    setupFontSize
    catchEvent
  end

  def setupFontSize
    hConf=$conf.getConf
    setFont(QFont.new("lcfont",@aFontSize[hConf[@confKey].to_i]))
  end

  def updownFont(i)
    hConf=$conf.getConf
    j=hConf[@confKey].to_i + i
    if j < 0 or j >= @aFontSize.size then
      return
    end
    hConf[@confKey]=j.to_s
    $conf.setConf(hConf)
    setupFontSize
  end

  def keyPressEvent(e)
    case e.key
    when 8207
      updownFont(-1)
      e.ignore
    when 8208
      updownFont(1)
      e.ignore
    when 4154
      $frmMain.setFocus2Menu
      e.ignore
    end
  end

  def getData
    h = $conf.getConf
    case h["strKeitai"]
    when $strDocomo
      $codec.fromUnicode(self.text).data.gsub(/\n/,"\r\n").replaceString
    when $strVodafone, $strAu
      $codec.fromUnicode(self.text).data.gsub(/\n/," ")
    end
  end

end

class RqrMailto < QVBox
  def initialize(p)
    super(p)
    h1=QHBox.new(self)
      QLabel.new(tr("衧"),h1)
     @leTo = QLineEdit.new(h1)
     h=$conf.getConf
     @leTo.setText(tr(h["strLastAdrs"]))

    h2=QHBox.new(self)
      QLabel.new(tr("ɽꡧ"),h2)
      @leSubject = QLineEdit.new(h2)
    @confKey="sizeMailFont"
    @meBody = RqrEdit.new(self,@confKey)
    @ckAdr=QCheckBox.new(tr("Ȥ"),h1)
    if h["strLastAdrs"]!="" then
      @ckAdr.setChecked(true)
    end
    h=QHBox.new(self)
      @btnSave = QPushButton.new(tr("᡼¸ ɲ"),h)
      @btnModSave = QPushButton.new(tr("᡼¸ "),h)
      @btnModSave.setEnabled(false)
      @btnLoad = QPushButton.new(tr("¸᡼ɹ"),h)
      connect(@btnSave,QSIGNAL("clicked()"),self,"saveMail")
      connect(@btnModSave,QSIGNAL("clicked()"),self,"modMail")
      connect(@btnLoad,QSIGNAL("clicked()"),self,"loadMail")
    @strModFile=""
    h=$conf.getConf
    if FileTest.directory?(h["pathMailOutbox"])==false then
      astrPath = h["pathMailOutbox"].split(/\//)
      astrPath.delete_at(0)
      strCur = "/"
      astrPath.each do |d|
        strCur << d + "/"
        if FileTest.directory?(strCur) == false then
          Dir.mkdir(strCur)
        end
      end
    end

    if $strZDBAT!="" and $env.deviceName!="SL-A300" then
      @btnAdrs = QPushButton.new(tr("ɥ쥹Ģ"),h1)
      connect(@btnAdrs,QSIGNAL("clicked()"),self,"selectAddress")
    end
  end


  def useNextAdress
    if @ckAdr.isChecked then
      @leTo.text
    else
      ""
    end
  end

  def updownFont(i)
    @meBody.updownFont(i)
  end

  def modMail
    saveMail(@strModMail)
  end

  def saveMail(strModFile = "")
    if QMessageBox::information(self,tr("¸ޤ"),tr("ϤƤ᡼ǡ\n¸ޤ"),QMessageBox::Yes|QMessageBox::Default,QMessageBox::No) != QMessageBox::Yes then
      return
    end
    strFile = Time.now.strftime("%y%m%d%H%M%S.txt")
    h=$conf.getConf
    fp = File.new(h["pathMailOutbox"]+"/"+strFile,"w")
    fp.print($codec.fromUnicode(@leTo.text).data+"\n"+$codec.fromUnicode(@leSubject.text).data+"\n"+$codec.fromUnicode(@meBody.text).data)
    fp.close
    if strModFile!="" then
      File.delete(h["pathMailOutbox"]+"/"+@strModFile)
      QMessageBox::information(self,tr("¸ޤ"),tr("ϤƤ᡼ǡ\n¸ޤ"),QMessageBox::Ok|QMessageBox::Default)
    else
      QMessageBox::information(self,tr("ɲ¸ޤ"),tr("ϤƤ᡼ǡ\nɲ¸ޤ"),QMessageBox::Ok|QMessageBox::Default)
    end
  end

  def loadMail
    if QMessageBox::information(self,tr("ɹޤ"),tr("ϤƤ᡼ǡ˴\n¸Ƥ᡼ǡɤ߹ߤޤ"),QMessageBox::Yes|QMessageBox::Default,QMessageBox::No) != QMessageBox::Yes then
      return
    end
    $mailSelectDialog.showMail
    if $mailSelectDialog.exec!=0 then
      strFile=$mailSelectDialog.getSelectedMail
      if strFile == "" then
        return
      end
      @strModFile=strFile
      @btnModSave.setEnabled(true)
      h=$conf.getConf
      fp = File.new(h["pathMailOutbox"]+"/"+strFile,"r")
      strTo = fp.gets.chomp
      strSubject = fp.gets.chomp
      strBody = ""
      fp.each do |line|
        strBody << line
      end
      fp.close
      @leTo.setText($codec.toUnicode(strTo))
      @leSubject.setText($codec.toUnicode(strSubject))
      @meBody.setText($codec.toUnicode(strBody))
      QMessageBox::information(self,tr("ɹޤ"),tr("¸Ƥ᡼ǡ\nɹޤ"),QMessageBox::Ok|QMessageBox::Default)
    end
  end

  def getData
    h=$conf.getConf
    case h["strKeitai"]

    when $strDocomo
      strTo = $codec.fromUnicode(@leTo.text).data.replaceString
      strSubject = $codec.fromUnicode(@leSubject.text).data.replaceString
      strBody = @meBody.getData
      "MATMSG:TO:" + strTo + ";SUB:" + strSubject + ";BODY:" + strBody + ";;"

    when $strVodafone, $strAu
      strTo = $codec.fromUnicode(@leTo.text).data
      strSubject = $codec.fromUnicode(@leSubject.text).data
      strBody = @meBody.getData
      "MAILTO:" + strTo + "\r\nBODY:" + strBody + "\r\nSUBJECT:" + strSubject + "\r\n"
    end

  end

  def selectAddress
    if $adrsDialog.exec != 0 then
      strTo = $adrsDialog.addressMail
      astrTo = strTo.split(" ")
      if astrTo.size > 1 then
        $mailDialog.setMail(astrTo)
        if $mailDialog.exec != 0 then
          strTo = $mailDialog.getMail
        else
          strTo = ""
        end
      end
      if strTo != "" then
        strCur = @leTo.text.utf8.data
        if strCur == "" then
          @leTo.setText(tr(strTo))
        else
          @leTo.setText(tr(strCur + ", " + strTo))
        end
      end
    end
  end
end

class RqrMailDialog < QDialog
  def initialize
    super(nil, "RqrMailDialog", true) # Modal Dialog
    setCaption(tr("᡼륢ɥ쥹"))
    vb=QVBox.new(self)
    vb.setFixedSize($env.defaultDialogSize,$env.defaultDialogSize)
    QLabel.new(tr("ʣΥ᡼륢ɥ쥹ޤ\n򤷤Ƥ"),vb)
    @list = QListView.new(vb)
    @list.addColumn(tr("᡼륢ɥ쥹"))
#   Index
    @list.addColumn("",0)
    @astrMail = nil
  end

  def setMail(astrMail)
    @astrMail = astrMail
    @list.clear
    @astrMail.each_with_index do |e, i|
      QListViewItem.new(@list,tr(e),i.to_s)
    end
    @list.setSelected(@list.firstChild, true)
  end

  def getMail
    ret=@list.selectedItem.text(1).utf8.data
    if ret==nil then
       ""
    else
       @astrMail[ret.to_i]
    end
  end
end

class RqrSelectMailDialog < QDialog
  def initialize
    super(nil, "RqrSelectMailDialog", true) # Modal Dialog
    setCaption(tr("¸᡼"))
    vb=QVBox.new(self)
    iWidth=$env.defaultDialogSize*4/3
    vb.setFixedSize(iWidth,$env.defaultDialogSize)
    @liMail=QListView.new(vb)
    @liMail.addColumn(tr(""),iWidth*2/10+5)
    @liMail.addColumn(tr("TO"),iWidth*3/10)
    @liMail.addColumn(tr("Subject"),iWidth*5/10-5)
    @liMail.addColumn("",0) #ǥå
    @liMail.setAllColumnsShowFocus(true)
    @liMail.setSorting(0,false)
    @btnDelete = QPushButton.new(tr(""),vb)
    @astrFiles=Array.new
    connect(@btnDelete,QSIGNAL("clicked()"),self,"deleteMail")
  end

  def showMail
    h = $conf.getConf
    @astrFiles.clear
    @astrFiles=Dir.entries(h["pathMailOutbox"])
    @astrFiles.sort!
    @liMail.clear
    @astrFiles.each_with_index do |strFile, i|
      if strFile != "" and strFile != "." and strFile != ".." then

        fp=File.open(h["pathMailOutbox"]+"/"+strFile,"r")

        strTo = $codec.toUnicode(fp.gets.chomp)
        strSubject = $codec.toUnicode(fp.gets.chomp)
        fp.close
        strDate = strFile[0,2] + "/" + strFile[2,2] + "/" + strFile[4,2] + " " + strFile[6,2] + ":" + strFile[8,2] + ":" + strFile[10,2]
        QListViewItem.new(@liMail,strDate,strTo,strSubject,i.to_s)
      end
    end
    @liMail.setSelected(@liMail.firstChild, true)
  end

  def getSelectedMail
    ret = @liMail.selectedItem.text(3).utf8.data
    if ret==nil then
      ""
    else
      @astrFiles[ret.to_i]
    end
  end

  def deleteMail
    strFile = getSelectedMail
    if strFile=="" then
      return
    end
    if QMessageBox::information(self,tr("ޤ"),tr("򤵤Ƥ᡼ǡޤ"),QMessageBox::Yes,QMessageBox::No|QMessageBox::Default) != QMessageBox::Yes then
      return
    end
    h=$conf.getConf
    File.delete(h["pathMailOutbox"]+"/"+strFile)
    showMail
  end
end


class RqrAddress < QVBox
  def initialize(p)
    super(p)
    sv = QScrollView.new(self)

#    sv.setHScrollBarMode(QScrollView::AlwaysOff)

    vb = QVBox.new(sv)
    sv.addChild(vb)

#TODO TabWidget ǤOK?Ȥꤢᤦ

      vb.setFixedWidth($env.getDesktopWidth-7-sv.verticalScrollBar.sizeHint.width-sv.sizeHint.width)

#DEBUG
#p "adr"
#p $tab.sizeHint.width
#p $tab.width
#p $tab.sizeHint.height
#p $tab.height

#p sv.verticalScrollBar.sizeHint.width
#p sv.sizeHint.width
#    if $env.getDesktopWidth > $env.getDesktopHeight then
#      vb.setFixedWidth($tab.sizeHint.width-sv.verticalScrollBar.sizeHint.width-sv.sizeHint.width)
#      vb.setFixedWidth($env.getDesktopWidth-7-sv.verticalScrollBar.sizeHint.width-sv.sizeHint.width)
#    else
#      vb.setFixedWidth($tab.sizeHint.height+142-sv.verticalScrollBar.sizeHint.height-sv.sizeHint.height-10)
#      vb.setFixedWidth($env.getDesktopWidth-sv.verticalScrollBar.sizeHint.height-sv.sizeHint.height)
      vb.setFixedWidth($env.getDesktopWidth-7-sv.verticalScrollBar.sizeHint.width-sv.sizeHint.width)
#    end

    @pCont=nil
#    hh=QHBox.new(vb)
#      vv=QVBox.new(hh)

#      h=QHBox.new(vv)
      h=QHBox.new(vb)
        QLabel.new(tr("̾"),h)
        @leLname = QLineEdit.new(h)
        QLabel.new(tr("̾"),h)
        @leFname = QLineEdit.new(h)
#      h=QHBox.new(vv)
      h=QHBox.new(vb)
        QLabel.new(tr("̎؎ގ "),h)
        @leLfurigana = QLineEdit.new(h)
        QLabel.new(tr("̾"),h)
        @leFfurigana = QLineEdit.new(h)
#      $ckHan=QCheckBox.new(tr("Ⱦ\nѴ"),hh)
#      hc=$conf.getConf
#      if hc["bHan"]=="TRUE" then
#        $ckHan.setChecked(true)
#      end

    h=QHBox.new(vb)
      QLabel.new(tr("á"),h)
      @leTel1 = QLineEdit.new(h)
      QLabel.new(tr(""),h)
      @leTel2 = QLineEdit.new(h)
    h=QHBox.new(vb)
      QLabel.new(tr("Mail1 "),h)
      @leEmail1 = QLineEdit.new(h)
    h=QHBox.new(vb)
      QLabel.new(tr("Mail2 "),h)
      @leEmail2 = QLineEdit.new(h)
    h=QHBox.new(vb)
      QLabel.new(tr("Mail3 "),h)
      @leEmail3 = QLineEdit.new(h)
    h=QHBox.new(vb)
      QLabel.new(tr("Memo"),h)
      @leMemo = RqrEdit.new(h,"sizeAdrsFont")
      @leMemo.setFixedHeight(($iFont+3)*4)

    h=QHBox.new(vb)
      QLabel.new(tr("*URL"),h)
      @leHP = QLineEdit.new(h)

    h=QHBox.new(vb)
      QLabel.new(tr("* "),h)
      @leAdrCountry = QLineEdit.new(h)
      QLabel.new(tr(""),h)
      @leAdrZip = QLineEdit.new(h)
      QLabel.new(tr("ƻܸ"),h)
      @leAdrPref = QLineEdit.new(h)
    h=QHBox.new(vb)
      QLabel.new(tr("Į¼"),h)
      @leAdrCity = QLineEdit.new(h)
    h=QHBox.new(vb)
      QLabel.new(tr(""),h)
      @leAdrBanchi = RqrEdit.new(h,"sizeAdrsBanchiFont")
      @leAdrBanchi.setFixedHeight(($iFont+3)*4)
    h=QHBox.new(vb)
      QLabel.new(tr("ֹ"),h)
      @leAdrHeya = QLineEdit.new(h)
      QLabel.new(tr("Ȣ"),h)
      @leAdrShisho = QLineEdit.new(h)

    if $strZDBAT!="" and $env.deviceName!="SL-A300" then
      h=QHBox.new(self)
        @btnPrev = QPushButton.new(tr(""),h)
        @btnAdrs = QPushButton.new(tr("ɥ쥹Ģ"),h)
        @btnNext = QPushButton.new(tr(""),h)
        @btnClear = QPushButton.new(tr("ꥢ"),h)
        @ckZap=QCheckBox.new(tr("Ϣ³Ѵ⡼"),h)
      connect(@btnPrev,QSIGNAL("clicked()"),self,"prevAddress") 
      connect(@btnAdrs,QSIGNAL("clicked()"),self,"selectAddress") 
      connect(@btnNext,QSIGNAL("clicked()"),self,"nextAddress") 
      connect(@btnClear,QSIGNAL("clicked()"),self,"clearAll") 
    end

    catchEvent
  end

  def updownFont(i)
    @leMemo.updownFont(i)
    @leAdrBanchi.updownFont(i)
  end

  def selectAddress
    if $adrsDialog.exec != 0 then
      showAddress($adrsDialog.addressAll)
    end
  end

  def isZapMode?
    if $strZDBAT!="" and $env.deviceName!="SL-A300" then
      @ckZap.isChecked
    else
      false
    end
  end

  def eofAddress?
    if $adrsDialog.ready? then
      $adrsDialog.eofAddress?
    else
      false
    end
  end

  def nextAddress
    if !$adrsDialog.ready? then
      $frmMain.setCaption(tr($rqr + "...ɥ쥹Ģ..."))
      @pCont = Proc.new {
        $adrsDialog.makeList
        $frmMain.setCaption(tr($rqr))
        showAddress($adrsDialog.addressAll)
      }
      startTimer(0)
    else
      showAddress($adrsDialog.nextAddressAll)
    end
  end

  def prevAddress
    if !$adrsDialog.ready? then
      $frmMain.setCaption(tr($rqr + "...ɥ쥹Ģ..."))
      @pCont = Proc.new {
        $adrsDialog.makeList
        $frmMain.setCaption(tr($rqr))
        showAddress($adrsDialog.addressAll)
      }
      startTimer(0)
    else
      showAddress($adrsDialog.prevAddressAll)
    end
  end

  def timerEvent(e)
    killTimers
    @pCont.call
  end

  def showAddress(hAdrs)
    if hAdrs==nil then 
      return
    end
    @leLname.setText(tr(hAdrs[2]))
    @leFname.setText(tr(hAdrs[3]))
    @leLfurigana.setText(tr(hAdrs[4]))
    @leFfurigana.setText(tr(hAdrs[5]))
    @leTel1.setText(tr(hAdrs[7]))
    @leTel2.setText(tr(hAdrs[8]))
    astrMail=hAdrs[6].split(" ",3)
    if astrMail[0]==nil then
      astrMail[0]=""
    end
    if astrMail[1]==nil then
      astrMail[1]=""
    end
    if astrMail[2]==nil then
      astrMail[2]=""
    end
    @leEmail1.setText(tr(astrMail[0]))
    @leEmail2.setText(tr(astrMail[1]))
    @leEmail3.setText(tr(astrMail[2]))
    @leHP.setText(tr(hAdrs[9]))
    @leAdrCountry.setText(tr(hAdrs[10]))
    @leAdrZip.setText(tr(hAdrs[11]))
    @leAdrPref.setText(tr(hAdrs[12]))
    @leAdrCity.setText(tr(hAdrs[13]))
    @leAdrBanchi.setText(tr(hAdrs[14]))
    @leAdrHeya.setText("")
    @leAdrShisho.setText("")
    @leMemo.setText(tr(hAdrs[15].gsub(/\r\n/,"\n")))

  end

  def clearAll()
    @leLname.setText("")
    @leFname.setText("")
    @leLfurigana.setText("")
    @leFfurigana.setText("")
    @leTel1.setText("")
    @leTel2.setText("")
    @leEmail1.setText("")
    @leEmail2.setText("")
    @leEmail3.setText("")
    @leHP.setText("")
    @leAdrCountry.setText("")
    @leAdrZip.setText("")
    @leAdrPref.setText("")
    @leAdrCity.setText("")
    @leAdrBanchi.setText("")
    @leAdrHeya.setText("")
    @leAdrShisho.setText("")
    @leMemo.setText("")
  end

  def getData
    h=$conf.getConf
    case h["strKeitai"]
    when $strDocomo
      strLname = $codec.fromUnicode(@leLname.text).data.replaceString
      strFname = $codec.fromUnicode(@leFname.text).data.replaceString
#      if $ckHan.isChecked==true then
        strLfurigana = $codec.fromUnicode($ecodec.toUnicode($ecodec.fromUnicode(@leLfurigana.text).data.zen2han)).data.replaceString
        strFfurigana = $codec.fromUnicode($ecodec.toUnicode($ecodec.fromUnicode(@leFfurigana.text).data.zen2han)).data.replaceString
#      else
#        strLfurigana = $codec.fromUnicode(@leLfurigana.text).data.replaceString
#        strFfurigana = $codec.fromUnicode(@leFfurigana.text).data.replaceString
#      end
      strTel1 = $codec.fromUnicode(@leTel1.text).data.replaceString
      strTel2 = $codec.fromUnicode(@leTel2.text).data.replaceString
      strEmail1 = $codec.fromUnicode(@leEmail1.text).data.replaceString
      strEmail2 = $codec.fromUnicode(@leEmail2.text).data.replaceString
      strEmail3 = $codec.fromUnicode(@leEmail3.text).data.replaceString
      strHP = $codec.fromUnicode(@leHP.text).data.replaceString
      strAdrCountry = $codec.fromUnicode(@leAdrCountry.text).data.replaceString
      strAdrZip = $codec.fromUnicode(@leAdrZip.text).data.replaceString
      strAdrPref = $codec.fromUnicode(@leAdrPref.text).data.replaceString
      strAdrCity = $codec.fromUnicode(@leAdrCity.text).data.replaceString
      strAdrBanchi = @leAdrBanchi.getData
      strAdrHeya = $codec.fromUnicode(@leAdrHeya.text).data.replaceString
      strAdrShisho = $codec.fromUnicode(@leAdrShisho.text).data.replaceString

      strMemo = @leMemo.getData

      strQr = "MECARD:"
      strQr << "N:" + strLname + "," + strFname if strLname + strFname !=""
      strQr << ";SOUND:" + strLfurigana + "," + strFfurigana if strLfurigana + strFfurigana !=""
      strQr << ";TEL:" + strTel1 if strTel1 != ""
      strQr << ";TEL:" + strTel2 if strTel2 != ""
      strQr << ";EMAIL:" + strEmail1 if strEmail1 !=""
      strQr << ";EMAIL:" + strEmail2 if strEmail2 !=""
      strQr << ";EMAIL:" + strEmail3 if strEmail3 !=""
      strQr << ";URL:" + strHP if strHP !=""
      strQr << ";NOTE:" + strMemo if strMemo !=""
      strAdr = strAdrShisho + strAdrHeya +  strAdrBanchi +  strAdrCity + strAdrPref + strAdrZip  + strAdrCountry 
      strQr << ";ADR:" + strAdrShisho + "," + strAdrHeya + ","  + strAdrBanchi + "," + strAdrCity + "," + strAdrPref + "," + strAdrZip  + "," + strAdrCountry if strAdr!=""
      strQr << ";;"

    when $strVodafone, $strAu
      strLname = $codec.fromUnicode(@leLname.text).data
      strFname = $codec.fromUnicode(@leFname.text).data

      strLfurigana = $codec.fromUnicode($ecodec.toUnicode($ecodec.fromUnicode(@leLfurigana.text).data.zen2han)).data
      strFfurigana = $codec.fromUnicode($ecodec.toUnicode($ecodec.fromUnicode(@leFfurigana.text).data.zen2han)).data

      strTel1 = $codec.fromUnicode(@leTel1.text).data
      strTel2 = $codec.fromUnicode(@leTel2.text).data
      strEmail1 = $codec.fromUnicode(@leEmail1.text).data
      strEmail2 = $codec.fromUnicode(@leEmail2.text).data
      strEmail3 = $codec.fromUnicode(@leEmail3.text).data
      strMemo = @leMemo.getData

      strQr =  "MEMORY:" + strMemo
      strQr << "\r\nNAME1:" + strLname + strFname if strLname + strFname !=""
      strQr << "\r\nNAME2:" + strLfurigana + strFfurigana if strLfurigana + strFfurigana !=""
      strQr << "\r\nMAIL1:" + strEmail1 if strEmail1 !=""
      strQr << "\r\nMAIL2:" + strEmail2 if strEmail2 !=""
      strQr << "\r\nMAIL3:" + strEmail3 if strEmail3 !=""  
      strQr << "\r\nTEL1:" + strTel1 if strTel1 !=""
      strQr << "\r\nTEL2:" + strTel2 if strTel2 !=""

      if h["strKeitai"]==$strAu then
        strAdrPref = $codec.fromUnicode(@leAdrPref.text).data
        strAdrCity = $codec.fromUnicode(@leAdrCity.text).data
        strAdrBanchi = @leAdrBanchi.getData
        strAdr = strAdrPref + strAdrCity + strAdrBanchi
        strQr << "\r\nADD:" + strAdr if strAdr != ""
      end

      strQr << "\r\n"

    end

    strQr
  end

end

class FormMain < QMainWindow
  def initialize
    super
    setCaption($rqr)
    @idMail = 0
    @idAdrs = 1
    @idText = 2
    vb=QVBox.new(self)
    setCentralWidget(vb)

      @tab = QTabWidget.new(vb)
      $tab = @tab

        @rqMail = RqrMailto.new(@tab)
        @tab.insertTab(@rqMail,tr("Mail"),@idMail)
        @rqAdrs = RqrAddress.new(@tab)
        @tab.insertTab(@rqAdrs,tr("Address"),@idAdrs)
        @leStr = RqrEdit.new(@tab)
        @tab.insertTab(@leStr,tr("Text"),@idText)

      @atab=[@rqMail,@rqAdrs,@leStr]

    h=$conf.getConf
    @tab.setCurrentPage(h["lastScreen"].to_i)
    h = QHBox.new(vb)
    @sbBunkatsu=QSpinBox.new(h)
    @sbBunkatsu.setMinValue(1)
    @sbBunkatsu.setMaxValue(16)
    @sbBunkatsu.setFixedWidth(60)
    le= QLabel.new(tr("ʬ"),h)
    le.setFixedWidth(100)
    @btnExec = QPushButton.new(tr("QRɤѴ"),h)

    @strLastData=""
    @strLastQr=""
    @strLastSize=""
    @strLastMargin=""
    @strLastPhone=""
    @bNextQr=nil
    @bRealZap=false
    @aiVMax = [-1,14,26,42,62,84,106,122,152,180,213,251,287,331,362,412,450,504,460,624,666,711,779,857,911,997,1059,1125,11901,1264,1370,1452,1538,1628,1722,1809,1911,1989,2099,2213,2331]
    @hMenuId=Hash.new
    @mbar=QMenuBar.new(self)
    @hPop=Hash.new
    ["ե","ե","","Mail"].each do |e|
      @hPop[e]=QPopupMenu.new
      @mbar.insertItem(tr(e),@hPop[e])
      connect(@hPop[e],QSIGNAL("activated(int)"),self,"activateMenu(id)")
    end
    p=@hPop["ե"]
    @hMenuId["setPixPath"]=p.insertItem(tr("ե¸ѹ"))
    p.setAccel(QAccel::stringToKey("Ctrl+F"),@hMenuId["setPixPath"])
    @hMenuId["setPixSize"]=p.insertItem(tr("ѹ"))
    p.setAccel(QAccel::stringToKey("Ctrl+R"),@hMenuId["setPixSize"])
    @hMenuId["execQr"]=p.insertItem(tr("QRɤѴ"))
    p.setAccel(QAccel::stringToKey("Ctrl+T"),@hMenuId["execQr"])


    @hMenuId["changeTab"]=p.insertItem(tr("ڤؤ"))
    p.setAccel(QAccel::stringToKey("Ctrl+H"),@hMenuId["changeTab"])


    p=@hPop["ե"]
    @hMenuId["upFontSize"]=p.insertItem(tr("ä礭"))
    @hMenuId["downFontSize"]=p.insertItem(tr("äȾ"))
    p=@hPop[""]
    @hMenuId["setDocomo"]=p.insertItem($strDocomo)
    @hMenuId["setAu"]=p.insertItem($strAu)
    @hMenuId["setVodafone"]=p.insertItem($strVodafone)
    @aMenuIdKeitai=[@hMenuId["setDocomo"],@hMenuId["setVodafone"]]
    @aMenuIdKeitai=[@hMenuId["setDocomo"],@hMenuId["setAu"],@hMenuId["setVodafone"]]
    p.setCheckable(true)
    p=@hPop["Mail"]
    @hMenuId["mailOpen"]=p.insertItem(tr("ɤ߹"))
    p.setAccel(QAccel::stringToKey("Ctrl+O"),@hMenuId["mailOpen"])
    @hMenuId["mailSaveAs"]=p.insertItem(tr("ɲ¸"))
    p.setAccel(QAccel::stringToKey("Ctrl+A"),@hMenuId["mailSaveAs"])
    @hMenuId["mailSave"]=p.insertItem(tr("¸"))
    p.setAccel(QAccel::stringToKey("Ctrl+S"),@hMenuId["mailSave"])

    if $strZDBAT!="" and $env.deviceName!="SL-A300" then

      @hMenuId["mailUseAdrs"]=p.insertItem(tr("ɥ쥹Ģ"))
      p.setAccel(QAccel::stringToKey("Ctrl+L"),@hMenuId["mailUseAdrs"])

      @hPop["Address"]=QPopupMenu.new
      @mbar.insertItem(tr("Address"),@hPop["Address"])
      p=@hPop["Address"]
      @hMenuId["adrsNextAdrs"]=p.insertItem(tr("Υɥ쥹"))
      p.setAccel(QAccel::stringToKey("Ctrl+N"),@hMenuId["adrsNextAdrs"])
      @hMenuId["adrsPrevAdrs"]=p.insertItem(tr("Υɥ쥹"))
      p.setAccel(QAccel::stringToKey("Ctrl+P"),@hMenuId["adrsPrevAdrs"])
      @hMenuId["adrsClearAdrs"]=p.insertItem(tr("ꥢ"))
      p.setAccel(QAccel::stringToKey("Ctrl+C"),@hMenuId["adrsClearAdrs"])
      @hMenuId["adrsUseAdrs"]=p.insertItem(tr("ɥ쥹Ģ"))
      p.setAccel(QAccel::stringToKey("Ctrl+L"),@hMenuId["adrsUseAdrs"])
      connect(@hPop["Address"],QSIGNAL("activated(int)"),self,"activateMenu(id)")
    end


    h=$conf.getConf
    setKeitai(h["strKeitai"])

    connect(@btnExec,QSIGNAL("clicked()"),self,"execQr")
    catchEvent
  end

  def activateMenu(id)
    case id
    when @hMenuId["execQr"]
      execQr
    when @hMenuId["changeTab"]
      changeTab
    when @hMenuId["upFontSize"]
      updownFont(1)
    when @hMenuId["downFontSize"]
      updownFont(-1)
    when @hMenuId["setPixSize"]
      if $sizeDialog.exec !=0 then
        $conf.setConf($sizeDialog.getConf)
      end
    when @hMenuId["setPixPath"]
      selectFileName
    when @hMenuId["setDocomo"]
      setKeitai($strDocomo)
    when @hMenuId["setAu"]
      setKeitai($strAu)
    when @hMenuId["setVodafone"]
      setKeitai($strVodafone)
    when @hMenuId["mailOpen"]
      @tab.setCurrentPage(@idMail)
      @rqMail.loadMail
    when @hMenuId["mailSaveAs"]
      @tab.setCurrentPage(@idMail)
      @rqMail.saveMail
    when @hMenuId["mailSave"]
      @tab.setCurrentPage(@idMail)
      @rqMail.modMail
    when @hMenuId["mailUseAdrs"]
      useAddress
    when @hMenuId["adrsUseAdrs"]
      useAddress
    when @hMenuId["adrsNextAdrs"]
      @tab.setCurrentPage(@idAdrs)
      @rqAdrs.nextAddress
    when @hMenuId["adrsPrevAdrs"]
      @tab.setCurrentPage(@idAdrs)
      @rqAdrs.prevAddress
    when @hMenuId["adrsClearAdrs"]
      @tab.setCurrentPage(@idAdrs)
      @rqAdrs.clearAll
    end
  end

  def useAddress
    case @tab.currentPageIndex
    when @idMail
      @rqMail.selectAddress
    when @idAdrs
      @rqAdrs.selectAddress
    end
  end

  def changeTab
    case @tab.currentPageIndex
    when @idMail
      @tab.setCurrentPage(@idAdrs)
    when @idAdrs
      @tab.setCurrentPage(@idText)
    when @idText
      @tab.setCurrentPage(@idMail)
    end
  
  end

  def setKeitai(strKeitai)
    p=@hPop[""]
    @aMenuIdKeitai.each do |id|
      p.setItemChecked(id,p.text(id).utf8.data==strKeitai)
    end
    h=$conf.getConf
    h["strKeitai"]=strKeitai
    $conf.setConf(h)
#    @rqAdrs.setHan
  end

  def updownFont(i)
    @atab[@tab.currentPageIndex].updownFont(i)
  end

  def selectFileName
    h = $conf.getConf
    begin
      if $fileDialog.showDialog(h["pathCurPix"]) ==0 then
        return
      end
      strFileName=$fileDialog.getSelectedFile
      strBaseName = $fileDialog.getSelectedFileOnly
    end while strBaseName==""
    h["pathCurPix"]=strFileName
    $conf.setConf(h)
  end

  def setFocus2Menu
    @mbar.setFocus
  end

  def execQr
    w = @tab.currentPageIndex
    case w
    when @idText
      execQrMain
    when @idMail
      execQrMain
    when @idAdrs
      if @rqAdrs.isZapMode? then
        case QMessageBox::warning(self, tr("Ϣ³Ѵ¹Ԥޤ"), tr("[Ϣ³Ѵ⡼]ꤵƤޤ\n[Ϣ³Ѵ⡼]ǤϡߤϥǡѴλ塢\n[] 졢\nɥ쥹Ģǡ֤Ѵޤ\nλˤ QRɽ\n[Cancel] 򲡤Ƥ\n[Ϣ³Ѵ]⡼ɤǼ¹Ԥޤ"), QMessageBox::Yes , QMessageBox::No | QMessageBox::Default)
        when QMessageBox::Yes
          execZapMode
        when QMessageBox::No
          QMessageBox::warning(self, tr("̤Ѵ"), tr("ɽƤǡΤѴޤ"), QMessageBox::Ok | QMessageBox::Default)
          @realZapMode=false
          execQrMain
        end
      else
        execQrMain
      end
    end
  end

  def execZapMode
    @realZapMode=true
    $rqrDialog.setCaption(tr("³:[OK]λ:[Cancel]"))
    execQrMain
  end

  def execZapModeCont
    if @bNextQr!=0 then 
      unless @rqAdrs.eofAddress?
        @rqAdrs.nextAddress
        execQrMain
      end
    else
      @realZapMode=false
      $rqrDialog.setCaption(tr($rqr))
    end
  end

  def execQrMain
    strData=@atab[@tab.currentPageIndex].getData
    
    h=$conf.getConf

    if strData==@strLastData and h["sizeQr"]==@strLastSize and h["bMargin"]==@strMargin and @h["strKeitai"]==@strLastPhone then
        @bNextQr = $rqrDialog.exec
        if @realZapMode then
          @pCont = Proc.new {
            execZapModeCont
          }
          startTimer(0)
        end


    else


      setCaption(tr($rqr + " Ѵ..."))
      @pCont = Proc.new {
        @strLastData=strData
        @strLastSize=h["sizeQr"]
        @strLastMargin=h["bMargin"]
        @strLastPhone=h["strKeitai"]

        iBun=@sbBunkatsu.value

        iLen=strData.length
        iOneLen=iLen/iBun
        h=$conf.getConf

          iVer = 0
          (1..@aiVMax.size-1).each do |i|
            if @aiVMax[i] > iOneLen then
              $iVer = i
              break
            end
          end

          fp = File.new(h["pathQrTmp"],"w")
          fp.print(strData)
          fp.close

          strQr=`#{ $strBinQr + " -v" + $iVer.to_s + " -b" + iBun.to_s + " -m8 -eM < " + h["pathQrTmp"]}`
          File.delete(h["pathQrTmp"])
          $astrQr=strQr.split(",")

        $rqrDialog.drawQr
        setCaption(tr($rqr))
        @bNextQr = $rqrDialog.exec

        if @realZapMode then
          @pCont = Proc.new {
            execZapModeCont
          }
          startTimer(0)
        end
      }
      startTimer(0)
    end

  end

  def timerEvent(e)
    killTimers
    @pCont.call
  end

  def closeEvent(e)
    case QMessageBox::warning(self, tr("λƤ褤Ǥ"), tr("˽λƤǤ"), QMessageBox::Yes , QMessageBox::No)
    when QMessageBox::Yes
      h = $conf.getConf
      h["lastScreen"]=@tab.currentPageIndex.to_s
      h["strLastAdrs"]=@rqMail.useNextAdress
      $conf.setConf(h)
      e.accept
    when QMessageBox::No
      e.ignore
    end
  end
end

class RqrFileDialog < QDialog
  def initialize
    super(nil, "RqrFileDialog", true) # Modal Dialog
    setCaption(tr("¸ե̾ꤷƲ"))
    vb=QVBox.new(self)
    vb.setFixedSize($env.defaultDialogSize,$env.defaultDialogSize)

    @dir = "/home/samba/Main_Memory"
    
    @dir.sub!(/\/usr\/mnt.rom\/cf/,"/home/samba/CF_Card")
    @dir.sub!(/\/usr\/mnt.rom\/card/,"/home/samba/SD_Card")
    if FileTest.directory?("/home/zaurus/") then
      @dir.sub!(/\/home\/zaurus\/Documents/,"/home/samba/Main_Memory")
    else
      @dir.sub!(/\/home\/root\/Documents/,"/home/samba/Main_Memory")
    end
    @dir.chomp!()
    @fname = ""

    @ckSave = QCheckBox.new(tr("QRɲư¸"),vb)

    @list = QListView.new(vb)
    if $env.largeScreen? then
      @list.addColumn("File Name",150)
      @list.addColumn("Size",80)
      @list.addColumn("DateTime",110)
    else
      @list.addColumn("File Name",100)
      @list.addColumn("Size",30)
      @list.addColumn("DateTime",80)
    end

    @list.setColumnAlignment(0,1)
    @list.setColumnAlignment(1,2)
    @list.setColumnAlignment(2,2)

    @f = Array.new()
    h=QHBox.new(vb)
    QLabel.new(tr("ե̾"),h)
    @le = QLineEdit.new(h)

    connect(@ckSave,QSIGNAL("stateChanged(int)"),self,"tglSave(i)")
    connect(@list, QSIGNAL("returnPressed(QListViewItem*)"), self, 'selectFile')

    setSave
  end

  def tglSave(i)
    h=$conf.getConf
    case i
    when 0
      h["bSavePix"]="FALSE"
    when 2
      h["bSavePix"]="TRUE"
    end
    $conf.setConf(h)
    setSave
  end

  def setSave
    h = $conf.getConf
    if h["bSavePix"]=="TRUE" then
      @list.setEnabled(true)
      @le.setEnabled(true)
      @ckSave.setChecked(true)
    else
      @list.setEnabled(false)
      @le.setEnabled(false)
      @ckSave.setChecked(false)
    end
  end

  def showDialog(df)
    if df[-1,1]=="/" then
      @dir=df
      @fname=""
    else
      aFile = File.split(df)
      @dir = aFile[0]
      @fname = aFile[1]
    end
    if File.directory?(@dir)==false then
      if FileTest.directory?("/home/zaurus/") then
        @dir = "/home/zaurus/Documents"
      else
        @dir = "/home/zaurus/Documents"
      end
    end      
    Dir.chdir(@dir)
    @fname="rqr.jpeg" if @fname==""
    @le.setText(tr(@fname))
    showFiles
    setSave
    exec
  end

  def showFiles
    @list.clear
    getDir
    i = 0
    setCaption(@dir)
    while i < @f.size
      strf=@f[i]
      case File.ftype(strf)
      when "directory"
        fs="dir"
        ft = File.mtime(strf)
      when "link"
        fs="link"
        ft = ""
      else
        fs=(File.size(strf) / 1024).to_s + "Kb "
        ft = File.mtime(strf).strftime("%y/%m/%d %H:%M:%S")
      end
      li = QListViewItem.new(@list,strf,fs,ft)
      @list.setSelected(li, true) if strf == @fname
      i += 1
    end
#    @fname = ""
  end

  def selectFile(selectedItem)
    sf = selectedItem.text(0).to_str
    b=true
    strType = File.ftype(sf)
    while b do
      case strType
      when "directory"
       Dir.chdir(sf)
        @dir =Dir.pwd
        showFiles
        b=false
      when "link"
        lsf = File.readlink(sf)
        if File.ftype(lsf)!="directory" then
          sf=File.dirname(lsf)
          @fname=File.basename(lsf)
          @le.setText(tr(@fname))
          strType="directory"
        else
          strType="directory"
          sf=lsf
        end
      else
        @fname = sf
        @le.setText(tr(@fname))
        b=false
      end
    end
  end

  def getDir
    @f.clear
    @f = Dir.entries("./")
    @f.sort!
  end
  
  def getSelectedFile
    if @dir[-1,1]=="/" then
      @dir + @le.text.data
    else
      @dir + "/" + @le.text.data
    end
  end
  
  def getSelectedFileOnly
    @le.text.data
  end
end

class RqrAddressDialog < QDialog
  def initialize
    super(nil, "RqAddressDialog", true) # Modal Dialog
    setFixedSize($env.defaultDialogSize, $env.defaultDialogSize)
    @lvAdrs = QListView.new(self)
    @lvAdrs.setFixedSize(size)

    @lvAdrs.addColumn("Name",110)
    @lvAdrs.addColumn("Address",225)
    @lvAdrs.addColumn("",0)
    @lvAdrs.addColumn("",0)
    @lvAdrs.setSorting(2,true)

    @lvAdrs.setAllColumnsShowFocus(true)

    @astrAdrs=nil

    @pCont=nil
    catchEvent
  end

  def ready?
    @astrAdrs!=nil
  end

  def makeList(bDialog = false)
    h=$conf.getConf
    bUseZdbat = false
    if FileTest.file?(h["pathAdrTmp"]) then


#VER0.1.0
      if File.mtime(h["pathAdrTmp"]) < File.mtime($strOrigAdr) then
        bUseZdbat = true
      end
    else
        bUseZdbat = true
    end

    if bUseZdbat then
      setCaption(tr("ɥ쥹Ģ..."))
    else
      setCaption(tr("å夫..."))
    end

    @pCont = Proc.new {
      @astrAdrs = getAddresses(bUseZdbat)
      @lvAdrs.clear
      @astrAdrs.each_with_index do |n, i|
        QListViewItem.new(@lvAdrs,tr(n[2]+n[3]),tr(n[6]),tr(n[4]+n[5]),i.to_s)
      end
      @lvAdrs.setSelected(@lvAdrs.firstChild, true)
      setCaption(tr("򤷤Ƥ"))
    }
    if bDialog then
      startTimer(0)
    else
      @pCont.call
    end
  end

  def getAddresses(bUseZdbat)
    h=$conf.getConf
    if bUseZdbat then 
#                                    2    3    4    5    6    7    8    9    10   11   12   13   14   15 
      `#{$strZDBAT + " address -r -f LNME,FNME,LNPR,FNPR,MAL1,TEL1,CPS1,HWEB,HCTR,HZIP,HSTA,HCTY,HSTR,MEM1 > " + h["pathAdrTmp"]}`
    end

    csvAdrs = CSV::Reader.create(File.open(h["pathAdrTmp"],"r"))
    aStrAddress = nil
    csvAdrs.each do |row|
      if aStrAddress == nil then
        aStrAddress = Array.new
      else
        aOneAddress = Array.new
        row.each do |col|
          aOneAddress.push col.data
        end
        aStrAddress.push aOneAddress
      end
    end

    aStrAddress
  end

  def exec
    if !ready? then
      @pCont = Proc.new {
        makeList(true)
      }
      startTimer(0)
    end
    super
  end

  def timerEvent(e)
    killTimers
    @pCont.call
  end

  def addressMail
    ret=@lvAdrs.selectedItem
    if ret==nil then
       ""
    else
       @astrAdrs[ret.text(3).utf8.data.to_i][6]
    end
  end

  def addressAll
    ret=@lvAdrs.selectedItem
    if ret==nil then
       nil
    else
       @astrAdrs[ret.text(3).utf8.data.to_i]
    end
  end

  def eofAddress?
    @lvAdrs.selectedItem.itemBelow == nil
  end

  def nextAddressAll
    lv = @lvAdrs.selectedItem.itemBelow
    if lv != nil then
      @lvAdrs.setSelected(lv,true)
    end
    addressAll
  end

  def prevAddressAll
    lv = @lvAdrs.selectedItem.itemAbove
    if lv != nil then
      @lvAdrs.setSelected(lv,true)
    end
    addressAll
  end

end

a = QPEApplication.new([$0] + ARGV)

$env  = RqrEnv.new

if $env.largeScreen? then
  $iBlock=8
  $iFont=18
else
  $iBlock=4
  $iFont=10
end

QPEApplication.setFont(QFont.new("lcfont",$iFont))

a.setDefaultCodec(QTextCodec.codecForName("EUC-JP"))

if FileTest.directory?("/home/zaurus/") then
  $conf = RqrConf.new
else
  $conf = RqrConf.new("/home/root/Settings/rqr.conf")
end
if $strZDBAT!="" and $env.deviceName!="SL-A300" then
  $adrsDialog = RqrAddressDialog.new
end
$sizeDialog = RqrSetPixSizeDialog.new
$fileDialog = RqrFileDialog.new
$mailDialog = RqrMailDialog.new
$mailSelectDialog = RqrSelectMailDialog.new
$frmMain = FormMain.new
$rqrDialog = RqrDialog.new
$rqrCanvas = $rqrDialog.getCanvas
a.showMainWidget($frmMain)
a.exec
